\chapter{Results}\label{ch:results}
This sections presents the results achieved with the benchmark explained in the above mentioned chapter \ref{ch:implementation} and the limited data recorded for this thesis. Due to the reasons explained in subsection \ref{ssec:daffy_problem} the results of the thesis is limited to measurements conducted with the software release \verb+master19+. It is certain that more discoveries can be made with the benchmark once more data is available and the new release \verb+daffy+ is running again. % todo missing res for dt loc sys
\\
Every measurement was taken at least twice and for at least a minute with and a minute without bag recording. From the average of this data the score is then calculated. For comparisons at time only one measurements of each side is used in the following sections. The used measurement is representative for all measurements as the variation of the score is minimal. More information concerning the stability and reproducibility can be found in section \ref{sec:repro_stab}.
\section{DB18}
While conducting the benchmark two generations were available where the bot type could be 100\% assessed (since they came from the original box). The \verb+DB18p1+ and the \verb+DB18p4+. Since the \verb+DB18p1+ and the \verb+DB18p2+ as well a the \verb+DB18p3+ and the \verb+DB18p4+ were both produced in close proximity without any changes of manufacturers, it is a decent representation of the \verb+DB18+ category.

\begin{table}[!htb]
    \begin{tabular}{|c|c|c|c|c|c|c|}
    \hline
     &  & \multicolumn{5}{c|}{Scores} \\ \cline{3-7} 
    \multirow{-2}{*}{Model Name} & \multirow{-2}{*}{Hostname} & Health & Lane Following & Engineering & Container & Total \\ \hline
     &  & \cellcolor[HTML]{C0C0C0}89 & \cellcolor[HTML]{C0C0C0}45 & 43 & 75 & 63 \\ \cline{3-7} 
     & \multirow{-2}{*}{autobot02} & \cellcolor[HTML]{C0C0C0}90 & \cellcolor[HTML]{C0C0C0}53 & 43 & 76 & 66 \\ \cline{2-7} 
     &  & \cellcolor[HTML]{C0C0C0}77 & \cellcolor[HTML]{C0C0C0}54 & 42 & 77 & 62 \\ \cline{3-7} 
    \multirow{-4}{*}{DB18p1} & \multirow{-2}{*}{autobot04} & \cellcolor[HTML]{C0C0C0}77 & \cellcolor[HTML]{C0C0C0}53 & 42 & 77 & 62 \\ \hline
     &  & 87 & \cellcolor[HTML]{C0C0C0}41 & 46 & 73 & 62 \\ \cline{3-7} 
    \multirow{-2}{*}{DB18p4} & \multirow{-2}{*}{autobot38} & 75 & \cellcolor[HTML]{C0C0C0}41 & 44 & 72 & 58 \\ \hline
    \end{tabular}
    \cprotect\caption{Comparison of Benchmark scores between \verb+DB18p1+ and \verb+DB18p4+}
    \label{tab:res_comp_db18}
\end{table}

\begin{comment}
    \begin{figure}[!htb]
      \begin{subfigure}{0.3\textwidth}
        \centering
        \includegraphics[width=.6\linewidth]{img/result/p1_ab_02_1.png}
      \end{subfigure}%
      \begin{subfigure}{0.3\textwidth}
        \centering
        \includegraphics[width=.6\linewidth]{img/result/p1_ab_04_1.png}
      \end{subfigure}
      \begin{subfigure}{0.3\textwidth}\quad
        \centering
        \includegraphics[width=.6\linewidth]{img/result/p4_ab_14_1.png}
      \end{subfigure}
      \medskip
    
      \begin{subfigure}{0.3\textwidth}
        \centering
        \includegraphics[width=.6\linewidth]{img/result/p1_ab_02_2.png}
      \end{subfigure}
      \begin{subfigure}{0.3\textwidth}
        \centering
        \includegraphics[width=.6\linewidth]{img/result/p1_ab_04_2.png}
      \end{subfigure}
      \begin{subfigure}{0.3\textwidth}
        \centering
        \includegraphics[width=.6\linewidth]{img/result/p4_ab_14_2.png}
      \end{subfigure}
      \cprotect\caption{Comparison of Benchmark scores between \verb+DB18p1+ and \verb+DB18p4+}
      \label{tab:res_comp_db18}
    \end{figure}
\end{comment}

Several measurements have been conducted, a selection of which can be found in figure \ref{tab:res_comp_db18}. The total score is within close proximity as are the scores for Containers and Engineering. Interesting is the difference of the health score between \verb+autobot02+ and \verb+autobot04+ and especially the difference of the lane following score between \verb+DB18p1+ and \verb+DB18p4+.

\paragraph{Health}
Looking at the graphs (figure \ref{fig:comp_healt_status}) of the different Duckiebots it is visible that the status if the \verb+autobot04+ is \verb+warn+ and \verb+ok+ of the \verb+autobot02+. Taking a closer look at the data \verb+JSON+ throttling has occurred due to under voltage. 

\begin{figure}[!htb]
  \begin{subfigure}{0.5\textwidth}
    \centering
    \includegraphics[width=.95\linewidth, trim={35 20 50 20}, clip ]{img/result/status_ab_02.png}
    \cprotect\caption{\verb+autobot02+}
  \end{subfigure}
  \begin{subfigure}{0.5\textwidth}
    \centering
    \includegraphics[width=.95\linewidth, trim={40 10 50 10}, clip ]{img/result/status_ab_04.png}
    \cprotect\caption{\verb+autobot04+}
  \end{subfigure}
  \cprotect\caption{Comparison of Raspberry Pi status between \verb+autobot02+ and \verb+autobot04+}
  \label{fig:comp_healt_status}
\end{figure}

\paragraph{Lane following}
Interesting recognition is that the lane detector latency of the \verb+DB18p4+ is higher as well as it shows a higher CPU usage. On the other hand the segments count is higher for the \verb+DB18p1+. This is displayed in figure \ref{tab:res_comp_db18_diff}.
\begin{figure}[!htb]
  \begin{subfigure}{0.5\textwidth}
    \centering
    \includegraphics[width=.95\linewidth, trim={45 10 65 10}, clip]{img/result/lat_p1.png}
    \cprotect\caption{\verb+DB18p1+}
  \end{subfigure}%
  \begin{subfigure}{0.5\textwidth}
    \centering
    \includegraphics[width=.95\linewidth, trim={50 10 60 10}, clip]{img/result/lat_p4.png}
    \cprotect\caption{\verb+DB18p4+}
  \end{subfigure}
  \medskip
  
  \begin{subfigure}{0.5\textwidth}
    \centering
    \includegraphics[width=.95\linewidth, trim={50 10 60 0}, clip]{img/result/segs_p1.png}
    \cprotect\caption{\verb+DB18p1+}
  \end{subfigure}%
  \begin{subfigure}{0.5\textwidth}
    \centering
    \includegraphics[width=.95\linewidth, trim={50 0 60 10}, clip]{img/result/segs_p4.png}
    \cprotect\caption{\verb+DB18p4+}
  \end{subfigure}
  \medskip

  \begin{subfigure}{0.5\textwidth}
    \centering
    \includegraphics[width=.95\linewidth, trim={50 10 60 10}, clip]{img/result/cpu_p1.png}
    \cprotect\caption{\verb+DB18p1+}
  \end{subfigure}
  \begin{subfigure}{0.5\textwidth}
    \centering
    \includegraphics[width=.95\linewidth, trim={50 10 60 10}, clip]{img/result/cpu_p4.png}
    \cprotect\caption{\verb+DB18p4+}
  \end{subfigure}
  \cprotect\caption{Comparison of Lane Detector measures between \verb+DB18p1+ and \verb+DB18p4+}
  \label{tab:res_comp_db18_diff}
\end{figure}

\newpage
\section{Raspberry Pi 4} %vs Raspberry Pi 3 B+}
The comparison between the Raspberry Pi 4 and  the Raspberry Pi 3 is visible in \ref{tab:res_comp_pi4}. Generally the score is similar with the most obvious difference being the lane following score. However,  the comparison has to be taken with a grain of salt as the Raspberry Pis use a different version of the operating system (HypriotOS, indicated by the \verb+--experimental+ flag in the \verb+init_sd_card+ command).

\begin{comment}
\begin{figure}[!htb]
  \begin{subfigure}{1\textwidth}
    \centering
    \includegraphics[width=.6\linewidth]{img/result/pi_4-pi4.png}
    \cprotect\caption{Raspberry Pi \verb^4B^}
  \end{subfigure}%
  \medskip

  \begin{subfigure}{1\textwidth}
    \centering
    \includegraphics[width=.6\linewidth]{img/result/pi_4-pi_3.png}
    \cprotect\caption{Raspberry Pi \verb^3B+^}
  \end{subfigure}%
  
  \cprotect\caption{Comparison of Benchmark scores between Raspberry Pi \verb+4B+ and \verb~3B+~}
  \label{tab:res_comp_pi4}
\end{figure}

\end{comment}


\begin{table}[!htb]
\begin{tabular}{|c|c|c|c|c|c|c|}
\hline
 &  & \multicolumn{5}{c|}{Scores} \\ \cline{3-7} 
\multirow{-2}{*}{Model Name} & \multirow{-2}{*}{Raspberry Pi} & Container & Engineering & Health & Lane Following & Total \\ \hline
 & 3B+ & 81 & 57 & 69 & 50 & 64 \\ \cline{2-7} 
 & 3B+ & 76 & 43 & 90 & 53 & 66 \\ \cline{2-7} 
 & 4B & 81 & 59 & 72 & \cellcolor[HTML]{C0C0C0}77 & 72 \\ \cline{2-7} 
\multirow{-4}{*}{DB18p4} & 4B & 81 & 59 & 68 & \cellcolor[HTML]{C0C0C0}78 & 72 \\ \hline
\end{tabular}

  \cprotect\caption{Comparison of Benchmark scores between Raspberry Pi \verb+4B+ and \verb~3B+~}
  \label{tab:res_comp_pi4}
\end{table}

\subsection{Lane following score}
The Raspberry Pi seems to perform better in the lane following score. This is analyzed further in this section. The most weighed measurements are displayed in figure \ref{tab:res_comp_pi4_lane}. Both the detected segments and the latency are lower for the Raspberry Pi \verb~4B~. It can't be excluded for sure that lane segments count is \textit{due to environmental changes} even though all the efforts made to calibrate and set up the environment equally. On a latency per detected segments basis the Raspberry Pi \verb~4B~ still shows a better performance. (Pi \verb~3B+~: $2.6 \frac{\text{ms}}{\text{lane segment}}$ and Pi \verb~4B~: $1.6 \frac{\text{ms}}{\text{lane segment}}$) However,  it needs to be investigated further whether the relation between detected segments and lane detector latency is linear.

\begin{figure}[!htb]
  \begin{subfigure}{0.5\textwidth}
    \centering
    \includegraphics[width=.8\linewidth]{img/result/pi4-pi3_ldnl.png}
    \cprotect\caption{Lane detector latency Pi \verb~3B+~}
  \end{subfigure}%
  \begin{subfigure}{0.5\textwidth}
    \centering
    \includegraphics[width=.8\linewidth]{img/result/pi4-pi4_ldnl.png}
    \cprotect\caption{Lane detector latency Pi \verb~4B~}
  \end{subfigure}
  \medskip

  \begin{subfigure}{0.5\textwidth}
    \centering
    \includegraphics[width=.8\linewidth]{img/result/pi4-pi3_segs.png}
    \cprotect\caption{Lane detector latency Pi \verb~3B+~}
  \end{subfigure}%
  \begin{subfigure}{0.5\textwidth}
    \centering
    \includegraphics[width=.8\linewidth]{img/result/pi4-pi4_segs.png}
    \cprotect\caption{Lane detector latency Pi \verb~4B~}
  \end{subfigure}
  \cprotect\caption{Comparison of Lane Detector measures between \verb+DB18p1+ and \verb+DB18p4+}
  \label{tab:res_comp_pi4_lane}
\end{figure}

\newpage
\section{Software Observations}
\subsection{Daffy} \label{ssec:daffy_problem}
In the first weeks of this thesis it was tried to run the benchmark with the software releases with \verb+master19+ and \verb+daffy+. \verb+daffy+ proved to be impossible to run stable lane following. Until the branch \verb+daffy_new_deal+ is completed and released as the new version of \verb+daffy+ this release had to be skipped for the rest of the thesis. \verb+daffy_new_deal+ promises better overall performance and should fix the current problem. 

\subsection{Docker image Size} \label{sec:docker_imsize}
While trying to run the localization system respectively the \verb+acquisition-bridge+ on a \verb+DB18p1+  the Duckietown shell threw the following error:
\\
\verb+  No space left on device+
\\
This indicates that during the last years (since the release of the \verb+DB18p1+) the overall storage requirements have increased. As the 16 GB SD-Card has been exchanged for one with 32 GB this has not been a problem yet. The Docker image of the acquisition bridge has a size of 784.21 MB, meaning from the \verb+init_sd_card+-procedure about 5\% of the SD-Card capacity are left on the device. 

\subsection{Acquisition Bridge}\label{sec:acq_bridge}
Using the acquisition bridge together with lane following \textbf{and} the diagnostics tool proved to be really difficult or even impossible using both \verb+master19+ and \verb+daffy+. This is due to the high CPU usage of the acquisition bridge visible in figure \ref{fig:acq_high}. The red line in the figure can be ignored, due to a bug in the Diagnostics tool, the data from the first process isn't displayed correctly. The lower measurements come from a second process used by the \verb+acquisition_bridge+. Same is visible in image \ref{fig:acq_compare}. However,  the difference is less visible as the all scores are an average over different measurements. Thus, the influence of one measurement is less well visible except for the health score as the high CPU usage caused temporary thermal throttling.

\begin{figure}[hbt!]
    \centering
    \includegraphics[width=.75\textwidth]{img/result/Acq_test.png}
    \caption{Benchmark Score, right with acquisition bridge, left without}
    \label{fig:acq_compare}
\end{figure}

\newpage

\begin{figure}[hbt!]
    \centering
    \includegraphics[trim={10 0 10 570},clip,width=.85\textwidth]{img/result/acquisition_bridge.png}
    \caption{Display of the stats of the acquisition-bridge \\ Please ignore the red line. Due to a bug, the data from the first process isn't displayed correctly.}
    \label{fig:acq_high}
\end{figure}

If the CPU usage of the \verb+acquisition_bridge+ is not reducible members of another ETH project\cite{drogone} recommended the \verb+FKIE Multimaster+ \cite{multimaster} ROS Package as a possible replacement. Among other things it synchronizes ROS topics across different devices with "{}minimal"{} CPU penalty. However, , no exact measurements concerning the CPU load have been conducted by the DroGone team. Nevertheless, it might be worth further evaluation. 

\newpage
\section{Other observations}
\subsection{Localization System Data} As discussed in section \ref{sec:docker_imsize} \verb+DB18p1+ proved to be impossible to install the \verb+acquisition-bridge+ according to the manual. Furthermore due to the high CPU usage (see section \ref{sec:acq_bridge}) localization turned out to be impossible. 

\subsection{SD-Card wear out}
While flashing the micro SD-Card of one of the \verb+DB18p1+ bots the card turned mid-flashing into read-only mode. From that moment on all writing attempts landed into the void and formatting is not possible as the partition table wasn't mutable anymore. Having done some research it seems like an effect of an early wear out. 

\subsection{Detection of Problems}
Figure \ref{fig:detect_err} displays a case where the lane detector score is low. Further investigation displays a rather high latency. Further investigation using the Duckietown troubleshooting tips in the manual \cite{dt_manual} helped displaying many really large and skew segments which then could be traced back to much natural light from the side.
\begin{figure}[hbt!]
    \begin{subfigure}{0.4\textwidth}
        \centering
        \includegraphics[width=.95\linewidth, trim={20 90 20 10}, clip]{img/result/problem_lf_score.png}
        \cprotect\caption{Low lane following score}
    \end{subfigure}
    \begin{subfigure}{0.6\textwidth}
        \centering
        \includegraphics[width=1\linewidth]{img/result/problem_ldn_lat.png}
        \cprotect\caption{Increased lane detector latency}
    \end{subfigure}
    \cprotect\caption{Low lane detector score}
    \label{fig:detect_err}
\end{figure}